package moje_jdbc;

import java.sql.*;

public class ConcurrentUpdate {
  public static void main(String args[]) {
    Connection con = null;

    try {
      Class.forName(Common.CLASSNAME).newInstance();
    }
    catch( Exception e ) {
      System.out.println("Failed to load driver.");
      return;
    }
    try {
      con = DriverManager.getConnection(Common.URL, Common.USERNAME, Common.PASSWORD);
      con.setAutoCommit(false);
      Statement s1 = con.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_UPDATABLE);
      ResultSet rs1 = s1.executeQuery("SELECT * FROM Product");
      Statement s2 = con.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_READ_ONLY);
      ResultSet rs2 = s2.executeQuery("SELECT * FROM Product");
      Statement s3 = con.createStatement(ResultSet.TYPE_FORWARD_ONLY, ResultSet.CONCUR_READ_ONLY);
      ResultSet rs3 = s3.executeQuery("SELECT * FROM Product");
      while (rs1.next())
        rs1.updateDouble(3, 2*rs1.getDouble(3));
      int diff12 = 0,
          diff13 = 0,
          diff23 = 0;
      
      System.out.print("Pierwsze porwnanie: ");
      System.out.flush();
      rs1.beforeFirst();
      while (rs1.next()) {
        rs2.next();
	rs3.next();
        if (rs1.getDouble(3) != rs2.getDouble(3))
	  diff12++;
        if (rs1.getDouble(3) != rs3.getDouble(3))
	  diff13++;
        if (rs2.getDouble(3) != rs3.getDouble(3))
	  diff23++;
      }
      System.out.println("diff12 = " + diff12 + ", diff13 = " + diff13 + ", diff23 = " + diff23);

      System.out.print("Drugie porwnanie: ");
      System.out.flush();
      rs1.beforeFirst();
      rs2.beforeFirst();
      while (rs1.next()) {
        rs2.next();
	rs1.refreshRow();
	rs2.refreshRow();
        if (rs1.getDouble(3) != rs2.getDouble(3))
	  diff12++;
      }
      System.out.println("diff12 = " + diff12);
      
      System.out.print("Trzecie porwnanie: ");
      System.out.flush();
      con.commit();
      rs1.beforeFirst();
      rs2.beforeFirst();
      while (rs1.next()) {
        rs2.next();
	rs1.refreshRow();
	rs2.refreshRow();
        if (rs1.getDouble(3) != rs2.getDouble(3))
	  diff12++;
      }
      System.out.println("diff12 = " + diff12);
      
      s1.close();
      s2.close();
    }
    catch( Exception e ) {
      e.printStackTrace();
    }
    finally {
      if( con != null ) {
        try { con.close(); }
        catch( SQLException e ) { e.printStackTrace(); }
      }
    }
  }
}
